bsp_flash_driver_hal_spi_map:
;hal_stm32.h,22 :: 		static void hal_spi_map ( const hal_spi_obj_t * spi_obj )
; spi_obj start address is: 0 (R0)
; spi_obj end address is: 0 (R0)
; spi_obj start address is: 0 (R0)
;hal_stm32.h,24 :: 		fp_spi_write = spi_obj->spi_write;
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_spi_write+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_spi_write+0)
STR	R2, [R1, #0]
;hal_stm32.h,25 :: 		fp_spi_read  = spi_obj->spi_read;
ADDS	R1, R0, #4
; spi_obj end address is: 0 (R0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_spi_read+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_spi_read+0)
STR	R2, [R1, #0]
;hal_stm32.h,26 :: 		}
L_end_hal_spi_map:
BX	LR
; end of bsp_flash_driver_hal_spi_map
bsp_flash_driver_hal_spi_write:
;hal_stm32.h,28 :: 		static void hal_spi_write ( uint8_t * buf, uint16_t len )
; len start address is: 4 (R1)
; buf start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
UXTH	R2, R1
; len end address is: 4 (R1)
; buf end address is: 0 (R0)
; buf start address is: 0 (R0)
; len start address is: 8 (R2)
;hal_stm32.h,30 :: 		uint8_t *ptr = buf;
; ptr start address is: 4 (R1)
MOV	R1, R0
; buf end address is: 0 (R0)
; len end address is: 8 (R2)
; ptr end address is: 4 (R1)
UXTH	R0, R2
;hal_stm32.h,32 :: 		while ( len-- )
L_bsp_flash_driver_hal_spi_write0:
; ptr start address is: 4 (R1)
; len start address is: 0 (R0)
; len start address is: 0 (R0)
UXTH	R3, R0
SUBS	R2, R0, #1
UXTH	R0, R2
; len end address is: 0 (R0)
CMP	R3, #0
IT	EQ
BEQ	L_bsp_flash_driver_hal_spi_write1
; len end address is: 0 (R0)
;hal_stm32.h,34 :: 		fp_spi_write( *( ptr++ ) );
; len start address is: 0 (R0)
LDRB	R2, [R1, #0]
UXTB	R4, R2
STRH	R0, [SP, #4]
STR	R1, [SP, #8]
UXTH	R0, R4
MOVW	R4, #lo_addr(bsp_flash_driver_fp_spi_write+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_spi_write+0)
LDR	R4, [R4, #0]
BLX	R4
LDR	R1, [SP, #8]
LDRH	R0, [SP, #4]
ADDS	R1, R1, #1
;hal_stm32.h,35 :: 		}
; len end address is: 0 (R0)
; ptr end address is: 4 (R1)
IT	AL
BAL	L_bsp_flash_driver_hal_spi_write0
L_bsp_flash_driver_hal_spi_write1:
;hal_stm32.h,36 :: 		}
L_end_hal_spi_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of bsp_flash_driver_hal_spi_write
bsp_flash_driver_hal_spi_read:
;hal_stm32.h,38 :: 		static void hal_spi_read ( uint8_t * buf, uint16_t len )
; buf start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
STRH	R1, [SP, #8]
; buf end address is: 0 (R0)
; buf start address is: 0 (R0)
;hal_stm32.h,40 :: 		uint8_t *ptr = buf;
STR	R0, [SP, #4]
; buf end address is: 0 (R0)
;hal_stm32.h,42 :: 		while ( len-- )
L_bsp_flash_driver_hal_spi_read2:
LDRH	R3, [SP, #8]
LDRH	R2, [SP, #8]
SUBS	R2, R2, #1
STRH	R2, [SP, #8]
CMP	R3, #0
IT	EQ
BEQ	L_bsp_flash_driver_hal_spi_read3
;hal_stm32.h,44 :: 		*( ptr++ ) = fp_spi_read( 0x00 );
MOVS	R0, #0
MOVW	R4, #lo_addr(bsp_flash_driver_fp_spi_read+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_spi_read+0)
LDR	R4, [R4, #0]
BLX	R4
LDR	R2, [SP, #4]
STRB	R0, [R2, #0]
LDR	R2, [SP, #4]
ADDS	R2, R2, #1
STR	R2, [SP, #4]
;hal_stm32.h,45 :: 		}
IT	AL
BAL	L_bsp_flash_driver_hal_spi_read2
L_bsp_flash_driver_hal_spi_read3:
;hal_stm32.h,46 :: 		}
L_end_hal_spi_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of bsp_flash_driver_hal_spi_read
bsp_flash_driver_hal_spi_transfer:
;hal_stm32.h,48 :: 		static void hal_spi_transfer ( uint8_t * buf_in, uint8_t * buf_out, uint16_t len )
; buf_out start address is: 4 (R1)
; buf_in start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STRH	R2, [SP, #12]
; buf_out end address is: 4 (R1)
; buf_in end address is: 0 (R0)
; buf_in start address is: 0 (R0)
; buf_out start address is: 4 (R1)
;hal_stm32.h,50 :: 		uint8_t *in = buf_in;
STR	R0, [SP, #4]
; buf_in end address is: 0 (R0)
;hal_stm32.h,51 :: 		uint8_t *out = buf_out;
STR	R1, [SP, #8]
; buf_out end address is: 4 (R1)
;hal_stm32.h,53 :: 		while ( len-- )
L_bsp_flash_driver_hal_spi_transfer4:
LDRH	R4, [SP, #12]
LDRH	R3, [SP, #12]
SUBS	R3, R3, #1
STRH	R3, [SP, #12]
CMP	R4, #0
IT	EQ
BEQ	L_bsp_flash_driver_hal_spi_transfer5
;hal_stm32.h,55 :: 		*( out++ ) = fp_spi_read( *( in++ ) );
LDR	R3, [SP, #4]
LDRB	R3, [R3, #0]
UXTB	R4, R3
UXTH	R0, R4
MOVW	R4, #lo_addr(bsp_flash_driver_fp_spi_read+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_spi_read+0)
LDR	R4, [R4, #0]
BLX	R4
LDR	R3, [SP, #8]
STRB	R0, [R3, #0]
LDR	R3, [SP, #8]
ADDS	R3, R3, #1
STR	R3, [SP, #8]
LDR	R3, [SP, #4]
ADDS	R3, R3, #1
STR	R3, [SP, #4]
;hal_stm32.h,56 :: 		}
IT	AL
BAL	L_bsp_flash_driver_hal_spi_transfer4
L_bsp_flash_driver_hal_spi_transfer5:
;hal_stm32.h,57 :: 		}
L_end_hal_spi_transfer:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of bsp_flash_driver_hal_spi_transfer
bsp_flash_driver_hal_i2c_map:
;hal_stm32.h,63 :: 		static void hal_i2c_map ( const hal_i2c_obj_t * i2c_obj )
; i2c_obj start address is: 0 (R0)
; i2c_obj end address is: 0 (R0)
; i2c_obj start address is: 0 (R0)
;hal_stm32.h,65 :: 		fp_i2c_start    = i2c_obj->i2c_start;
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_i2c_start+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_i2c_start+0)
STR	R2, [R1, #0]
;hal_stm32.h,66 :: 		fp_i2c_write    = i2c_obj->i2c_write;
ADDS	R1, R0, #4
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_i2c_write+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_i2c_write+0)
STR	R2, [R1, #0]
;hal_stm32.h,67 :: 		fp_i2c_read     = i2c_obj->i2c_read;
ADDW	R1, R0, #8
; i2c_obj end address is: 0 (R0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_i2c_read+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_i2c_read+0)
STR	R2, [R1, #0]
;hal_stm32.h,68 :: 		}
L_end_hal_i2c_map:
BX	LR
; end of bsp_flash_driver_hal_i2c_map
bsp_flash_driver_hal_i2c_start:
;hal_stm32.h,70 :: 		static int hal_i2c_start ( void )
SUB	SP, SP, #8
STR	LR, [SP, #0]
;hal_stm32.h,72 :: 		int res = 0;
MOVW	R4, #0
STRH	R4, [SP, #4]
;hal_stm32.h,74 :: 		res |= fp_i2c_start( );
MOVW	R4, #lo_addr(bsp_flash_driver_fp_i2c_start+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_i2c_start+0)
LDR	R4, [R4, #0]
BLX	R4
LDRSH	R1, [SP, #4]
ORR	R0, R1, R0, LSL #0
;hal_stm32.h,76 :: 		return res;
SXTH	R0, R0
;hal_stm32.h,77 :: 		}
L_end_hal_i2c_start:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of bsp_flash_driver_hal_i2c_start
bsp_flash_driver_hal_i2c_write:
;hal_stm32.h,79 :: 		static int hal_i2c_write ( uint8_t slaveAddress, uint8_t * pBuf, uint16_t nBytes, uint8_t endMode )
; endMode start address is: 12 (R3)
; nBytes start address is: 8 (R2)
; pBuf start address is: 4 (R1)
; slaveAddress start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; endMode end address is: 12 (R3)
; nBytes end address is: 8 (R2)
; pBuf end address is: 4 (R1)
; slaveAddress end address is: 0 (R0)
; slaveAddress start address is: 0 (R0)
; pBuf start address is: 4 (R1)
; nBytes start address is: 8 (R2)
; endMode start address is: 12 (R3)
;hal_stm32.h,81 :: 		int res = 0;
MOVW	R4, #0
STRH	R4, [SP, #4]
;hal_stm32.h,84 :: 		res |= fp_i2c_write( slaveAddress, ptr, nBytes, endMode );
; endMode end address is: 12 (R3)
; nBytes end address is: 8 (R2)
; pBuf end address is: 4 (R1)
; slaveAddress end address is: 0 (R0)
MOVW	R4, #lo_addr(bsp_flash_driver_fp_i2c_write+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_i2c_write+0)
LDR	R4, [R4, #0]
BLX	R4
LDRSH	R4, [SP, #4]
ORRS	R4, R0
;hal_stm32.h,86 :: 		return res;
SXTH	R0, R4
;hal_stm32.h,87 :: 		}
L_end_hal_i2c_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of bsp_flash_driver_hal_i2c_write
bsp_flash_driver_hal_i2c_read:
;hal_stm32.h,89 :: 		static int hal_i2c_read( uint8_t slaveAddress, uint8_t * pBuf, uint16_t nBytes, uint8_t endMode )
; endMode start address is: 12 (R3)
; nBytes start address is: 8 (R2)
; pBuf start address is: 4 (R1)
; slaveAddress start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; endMode end address is: 12 (R3)
; nBytes end address is: 8 (R2)
; pBuf end address is: 4 (R1)
; slaveAddress end address is: 0 (R0)
; slaveAddress start address is: 0 (R0)
; pBuf start address is: 4 (R1)
; nBytes start address is: 8 (R2)
; endMode start address is: 12 (R3)
;hal_stm32.h,91 :: 		int res = 0;
MOVW	R4, #0
STRH	R4, [SP, #4]
;hal_stm32.h,94 :: 		fp_i2c_read( slaveAddress, ptr, nBytes, endMode );
; endMode end address is: 12 (R3)
; nBytes end address is: 8 (R2)
; pBuf end address is: 4 (R1)
; slaveAddress end address is: 0 (R0)
MOVW	R4, #lo_addr(bsp_flash_driver_fp_i2c_read+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_i2c_read+0)
LDR	R4, [R4, #0]
BLX	R4
;hal_stm32.h,96 :: 		return res;
LDRSH	R0, [SP, #4]
;hal_stm32.h,97 :: 		}
L_end_hal_i2c_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of bsp_flash_driver_hal_i2c_read
bsp_flash_driver_hal_uart_map:
;hal_stm32.h,103 :: 		static void hal_uart_map ( const hal_uart_obj_t * uart_obj )
; uart_obj start address is: 0 (R0)
; uart_obj end address is: 0 (R0)
; uart_obj start address is: 0 (R0)
;hal_stm32.h,105 :: 		fp_uart_write = uart_obj->uart_write;
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_uart_write+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_uart_write+0)
STR	R2, [R1, #0]
;hal_stm32.h,106 :: 		fp_uart_read  = uart_obj->uart_read;
ADDS	R1, R0, #4
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_uart_read+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_uart_read+0)
STR	R2, [R1, #0]
;hal_stm32.h,107 :: 		fp_uart_ready = uart_obj->uart_ready;
ADDW	R1, R0, #8
; uart_obj end address is: 0 (R0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_uart_ready+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_uart_ready+0)
STR	R2, [R1, #0]
;hal_stm32.h,108 :: 		}
L_end_hal_uart_map:
BX	LR
; end of bsp_flash_driver_hal_uart_map
bsp_flash_driver_hal_uart_write:
;hal_stm32.h,110 :: 		static void hal_uart_write ( uint8_t input )
; input start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; input end address is: 0 (R0)
; input start address is: 0 (R0)
;hal_stm32.h,112 :: 		fp_uart_write( input );
; input end address is: 0 (R0)
MOVW	R4, #lo_addr(bsp_flash_driver_fp_uart_write+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_uart_write+0)
LDR	R4, [R4, #0]
BLX	R4
;hal_stm32.h,113 :: 		}
L_end_hal_uart_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_uart_write
bsp_flash_driver_hal_uart_read:
;hal_stm32.h,115 :: 		static uint8_t hal_uart_read ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;hal_stm32.h,117 :: 		return ( uint8_t ) fp_uart_read( );
MOVW	R4, #lo_addr(bsp_flash_driver_fp_uart_read+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_uart_read+0)
LDR	R4, [R4, #0]
BLX	R4
UXTB	R0, R0
;hal_stm32.h,118 :: 		}
L_end_hal_uart_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_uart_read
bsp_flash_driver_hal_uart_ready:
;hal_stm32.h,120 :: 		static uint8_t hal_uart_ready ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;hal_stm32.h,122 :: 		return ( uint8_t ) fp_uart_ready( );
MOVW	R4, #lo_addr(bsp_flash_driver_fp_uart_ready+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_uart_ready+0)
LDR	R4, [R4, #0]
BLX	R4
UXTB	R0, R0
;hal_stm32.h,123 :: 		}
L_end_hal_uart_ready:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_uart_ready
bsp_flash_driver_hal_pwm_map:
;hal_stm32.h,129 :: 		static void hal_pwm_map ( const hal_pwm_obj_t * pwm_obj )
; pwm_obj start address is: 0 (R0)
; pwm_obj end address is: 0 (R0)
; pwm_obj start address is: 0 (R0)
;hal_stm32.h,131 :: 		fp_pwm_set_duty = pwm_obj->pwm_duty;
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_pwm_set_duty+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_pwm_set_duty+0)
STR	R2, [R1, #0]
;hal_stm32.h,133 :: 		fp_pwm_stop     = pwm_obj->pwm_stop;
ADDS	R1, R0, #4
; pwm_obj end address is: 0 (R0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_pwm_stop+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_pwm_stop+0)
STR	R2, [R1, #0]
;hal_stm32.h,134 :: 		}
L_end_hal_pwm_map:
BX	LR
; end of bsp_flash_driver_hal_pwm_map
bsp_flash_driver_hal_pwm_start:
;hal_stm32.h,136 :: 		static void hal_pwm_start ( uint32_t channel, uint32_t duty, uint32_t invert/*, const Module_Struct * module */)
; invert start address is: 8 (R2)
; duty start address is: 4 (R1)
; channel start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; invert end address is: 8 (R2)
; duty end address is: 4 (R1)
; channel end address is: 0 (R0)
; channel start address is: 0 (R0)
; duty start address is: 4 (R1)
; invert start address is: 8 (R2)
;hal_stm32.h,138 :: 		fp_pwm_set_duty( ( unsigned int ) duty, ( char ) invert, ( char ) channel );
STR	R1, [SP, #4]
; channel end address is: 0 (R0)
UXTB	R1, R2
UXTB	R2, R0
; invert end address is: 8 (R2)
LDRH	R0, [SP, #4]
; duty end address is: 4 (R1)
MOVW	R4, #lo_addr(bsp_flash_driver_fp_pwm_set_duty+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_pwm_set_duty+0)
LDR	R4, [R4, #0]
BLX	R4
;hal_stm32.h,140 :: 		}
L_end_hal_pwm_start:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of bsp_flash_driver_hal_pwm_start
bsp_flash_driver_hal_pwm_stop:
;hal_stm32.h,142 :: 		static void hal_pwm_stop ( uint32_t channel )
; channel start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; channel end address is: 0 (R0)
; channel start address is: 0 (R0)
;hal_stm32.h,144 :: 		fp_pwm_stop( ( char ) channel );
UXTB	R0, R0
; channel end address is: 0 (R0)
MOVW	R4, #lo_addr(bsp_flash_driver_fp_pwm_stop+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_pwm_stop+0)
LDR	R4, [R4, #0]
BLX	R4
;hal_stm32.h,145 :: 		}
L_end_hal_pwm_stop:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_pwm_stop
bsp_flash_driver_hal_adc_map:
;hal_stm32.h,150 :: 		static void hal_adc_map ( const hal_adc_obj_t * adc_obj )
; adc_obj start address is: 0 (R0)
; adc_obj end address is: 0 (R0)
; adc_obj start address is: 0 (R0)
;hal_stm32.h,152 :: 		fp_adc_read       = adc_obj->adc_read;
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_adc_read+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_adc_read+0)
STR	R2, [R1, #0]
;hal_stm32.h,153 :: 		fp_adc_get_sample = adc_obj->adc_sample;
ADDS	R1, R0, #4
; adc_obj end address is: 0 (R0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(bsp_flash_driver_fp_adc_get_sample+0)
MOVT	R1, #hi_addr(bsp_flash_driver_fp_adc_get_sample+0)
STR	R2, [R1, #0]
;hal_stm32.h,154 :: 		}
L_end_hal_adc_map:
BX	LR
; end of bsp_flash_driver_hal_adc_map
bsp_flash_driver_hal_adc_read:
;hal_stm32.h,156 :: 		static uint32_t hal_adc_read ( uint32_t channel )
; channel start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; channel end address is: 0 (R0)
; channel start address is: 0 (R0)
;hal_stm32.h,158 :: 		return ( uint32_t ) fp_adc_read( ( unsigned int ) channel );
UXTH	R0, R0
; channel end address is: 0 (R0)
MOVW	R4, #lo_addr(bsp_flash_driver_fp_adc_read+0)
MOVT	R4, #hi_addr(bsp_flash_driver_fp_adc_read+0)
LDR	R4, [R4, #0]
BLX	R4
UXTH	R1, R0
MOV	R0, R1
;hal_stm32.h,159 :: 		}
L_end_hal_adc_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_adc_read
bsp_flash_driver_Write_to_Data_Lines:
;mmb_4_fpi_stm32.h,86 :: 		static void Write_to_Data_Lines ( unsigned char _hi, unsigned char _lo )
; _lo start address is: 4 (R1)
; _hi start address is: 0 (R0)
; _lo end address is: 4 (R1)
; _hi end address is: 0 (R0)
; _hi start address is: 0 (R0)
; _lo start address is: 4 (R1)
;mmb_4_fpi_stm32.h,88 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 12 (R3)
LDR	R3, [R2, #0]
;mmb_4_fpi_stm32.h,89 :: 		tmp &= 0xFF00;
AND	R2, R3, #65280
UXTH	R2, R2
; tmp end address is: 12 (R3)
;mmb_4_fpi_stm32.h,90 :: 		GPIOE_ODR = tmp | _hi;
ORR	R3, R2, R0, LSL #0
UXTH	R3, R3
; _hi end address is: 0 (R0)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_4_fpi_stm32.h,91 :: 		tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 0 (R0)
LDR	R0, [R2, #0]
;mmb_4_fpi_stm32.h,92 :: 		tmp &= 0xFF00;
AND	R2, R0, #65280
UXTH	R2, R2
; tmp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,93 :: 		GPIOE_ODR = tmp | _lo;
ORR	R3, R2, R1, LSL #0
UXTH	R3, R3
; _lo end address is: 4 (R1)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_4_fpi_stm32.h,94 :: 		}
L_end_Write_to_Data_Lines:
BX	LR
; end of bsp_flash_driver_Write_to_Data_Lines
bsp_flash_driver_Write_to_Data_Lines_8bit:
;mmb_4_fpi_stm32.h,96 :: 		static void Write_to_Data_Lines_8bit ( unsigned char _data )
; _data start address is: 0 (R0)
; _data end address is: 0 (R0)
; _data start address is: 0 (R0)
;mmb_4_fpi_stm32.h,98 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 8 (R2)
LDR	R2, [R1, #0]
;mmb_4_fpi_stm32.h,99 :: 		tmp &= 0xFF00;
AND	R1, R2, #65280
UXTH	R1, R1
; tmp end address is: 8 (R2)
;mmb_4_fpi_stm32.h,100 :: 		GPIOE_ODR = tmp | _data;
ORR	R2, R1, R0, LSL #0
UXTH	R2, R2
; _data end address is: 0 (R0)
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
STR	R2, [R1, #0]
;mmb_4_fpi_stm32.h,101 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,102 :: 		asm nop;
NOP
;mmb_4_fpi_stm32.h,103 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,104 :: 		}
L_end_Write_to_Data_Lines_8bit:
BX	LR
; end of bsp_flash_driver_Write_to_Data_Lines_8bit
bsp_flash_driver_Set_Index:
;mmb_4_fpi_stm32.h,106 :: 		static void Set_Index ( unsigned short index )
; index start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; index end address is: 0 (R0)
; index start address is: 0 (R0)
;mmb_4_fpi_stm32.h,108 :: 		TFT_RS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_4_fpi_stm32.h,109 :: 		Write_to_Data_Lines(0, index);
UXTB	R1, R0
; index end address is: 0 (R0)
MOVS	R0, #0
BL	bsp_flash_driver_Write_to_Data_Lines+0
;mmb_4_fpi_stm32.h,110 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,111 :: 		asm nop;
NOP
;mmb_4_fpi_stm32.h,112 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,113 :: 		}
L_end_Set_Index:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_Set_Index
bsp_flash_driver_Write_Command:
;mmb_4_fpi_stm32.h,115 :: 		static void Write_Command ( unsigned short cmd )
; cmd start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; cmd end address is: 0 (R0)
; cmd start address is: 0 (R0)
;mmb_4_fpi_stm32.h,117 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_4_fpi_stm32.h,118 :: 		Write_to_Data_Lines(0, cmd);
UXTB	R1, R0
; cmd end address is: 0 (R0)
MOVS	R0, #0
BL	bsp_flash_driver_Write_to_Data_Lines+0
;mmb_4_fpi_stm32.h,119 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,120 :: 		asm nop;
NOP
;mmb_4_fpi_stm32.h,121 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,122 :: 		}
L_end_Write_Command:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_Write_Command
bsp_flash_driver_Write_Data:
;mmb_4_fpi_stm32.h,124 :: 		static void Write_Data ( unsigned int _data )
; _data start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
UXTH	R3, R0
; _data end address is: 0 (R0)
; _data start address is: 12 (R3)
;mmb_4_fpi_stm32.h,128 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_4_fpi_stm32.h,129 :: 		temp = (_data>>11);
LSRS	R1, R3, #11
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_4_fpi_stm32.h,130 :: 		temp = (temp<<3);
LSLS	R1, R0, #3
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_4_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_bsp_flash_driver_Write_Data33
;mmb_4_fpi_stm32.h,134 :: 		temp += 7;
ADDS	R1, R4, #7
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,135 :: 		}
IT	AL
BAL	L_bsp_flash_driver_Write_Data6
L_bsp_flash_driver_Write_Data33:
;mmb_4_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_4_fpi_stm32.h,135 :: 		}
L_bsp_flash_driver_Write_Data6:
;mmb_4_fpi_stm32.h,137 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	bsp_flash_driver_Write_to_Data_Lines_8bit+0
;mmb_4_fpi_stm32.h,138 :: 		temp = (_data>>5);
LSRS	R1, R3, #5
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_4_fpi_stm32.h,139 :: 		temp = (temp<<2);
LSLS	R1, R0, #2
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_4_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_bsp_flash_driver_Write_Data34
;mmb_4_fpi_stm32.h,143 :: 		temp += 3;
ADDS	R1, R4, #3
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,144 :: 		}
IT	AL
BAL	L_bsp_flash_driver_Write_Data7
L_bsp_flash_driver_Write_Data34:
;mmb_4_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_4_fpi_stm32.h,144 :: 		}
L_bsp_flash_driver_Write_Data7:
;mmb_4_fpi_stm32.h,146 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	bsp_flash_driver_Write_to_Data_Lines_8bit+0
;mmb_4_fpi_stm32.h,147 :: 		temp = (_data<<3);
LSLS	R1, R3, #3
; _data end address is: 12 (R3)
; temp start address is: 12 (R3)
UXTB	R3, R1
;mmb_4_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
LSRS	R1, R3, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_bsp_flash_driver_Write_Data35
;mmb_4_fpi_stm32.h,151 :: 		temp += 7;
ADDS	R1, R3, #7
; temp end address is: 12 (R3)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,152 :: 		}
IT	AL
BAL	L_bsp_flash_driver_Write_Data8
L_bsp_flash_driver_Write_Data35:
;mmb_4_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
UXTB	R0, R3
;mmb_4_fpi_stm32.h,152 :: 		}
L_bsp_flash_driver_Write_Data8:
;mmb_4_fpi_stm32.h,154 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	bsp_flash_driver_Write_to_Data_Lines_8bit+0
;mmb_4_fpi_stm32.h,155 :: 		}
L_end_Write_Data:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_Write_Data
bsp_flash_driver_hal_display_init:
;mmb_4_fpi_stm32.h,157 :: 		static void hal_display_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,161 :: 		TFT_Set_Active( Set_Index, Write_Command, Write_Data );
MOVW	R2, #lo_addr(bsp_flash_driver_Write_Data+0)
MOVT	R2, #hi_addr(bsp_flash_driver_Write_Data+0)
MOVW	R1, #lo_addr(bsp_flash_driver_Write_Command+0)
MOVT	R1, #hi_addr(bsp_flash_driver_Write_Command+0)
MOVW	R0, #lo_addr(bsp_flash_driver_Set_Index+0)
MOVT	R0, #hi_addr(bsp_flash_driver_Set_Index+0)
BL	_TFT_Set_Active+0
;mmb_4_fpi_stm32.h,162 :: 		TFT_Init_SSD1963_Board_43( 480, 272 );
MOVW	R1, #272
MOVW	R0, #480
BL	_TFT_Init_SSD1963_Board_43+0
;mmb_4_fpi_stm32.h,163 :: 		TFT_Set_DBC_SSD1963( 255 );
MOVS	R0, #255
BL	_TFT_Set_DBC_SSD1963+0
;mmb_4_fpi_stm32.h,164 :: 		}
L_end_hal_display_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_display_init
bsp_flash_driver_hal_touch_init:
;mmb_4_fpi_stm32.h,170 :: 		static uint8_t hal_touch_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,174 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,175 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_7 );
MOVW	R1, #128
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,177 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_4_fpi_stm32.h,179 :: 		while (GPIOB_IDR.B7 == 0)
L_bsp_flash_driver_hal_touch_init9:
MOVW	R0, #lo_addr(GPIOB_IDR+0)
MOVT	R0, #hi_addr(GPIOB_IDR+0)
_LX	[R0, ByteOffset(GPIOB_IDR+0)]
CMP	R0, #0
IT	NE
BNE	L_bsp_flash_driver_hal_touch_init10
;mmb_4_fpi_stm32.h,181 :: 		GPIOB_ODR.B6 = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_4_fpi_stm32.h,182 :: 		Delay_us(10);
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_bsp_flash_driver_hal_touch_init11:
SUBS	R7, R7, #1
BNE	L_bsp_flash_driver_hal_touch_init11
NOP
NOP
NOP
;mmb_4_fpi_stm32.h,183 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_4_fpi_stm32.h,184 :: 		Delay_us(10);
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_bsp_flash_driver_hal_touch_init13:
SUBS	R7, R7, #1
BNE	L_bsp_flash_driver_hal_touch_init13
NOP
NOP
NOP
;mmb_4_fpi_stm32.h,185 :: 		}
IT	AL
BAL	L_bsp_flash_driver_hal_touch_init9
L_bsp_flash_driver_hal_touch_init10:
;mmb_4_fpi_stm32.h,187 :: 		I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #6784
MOVT	R0, #6
BL	_I2C1_Init_Advanced+0
;mmb_4_fpi_stm32.h,189 :: 		FT5XX6_SetI2CAddress( 0x38 );
MOVS	R0, #56
BL	_FT5XX6_SetI2CAddress+0
;mmb_4_fpi_stm32.h,191 :: 		if (FT5XX6_IsOperational( ) != FT5XX6_OK)
BL	_FT5XX6_IsOperational+0
CMP	R0, #0
IT	EQ
BEQ	L_bsp_flash_driver_hal_touch_init15
;mmb_4_fpi_stm32.h,193 :: 		return  FT5XX6_FAILURE;
MOVS	R0, #1
IT	AL
BAL	L_end_hal_touch_init
;mmb_4_fpi_stm32.h,194 :: 		}
L_bsp_flash_driver_hal_touch_init15:
;mmb_4_fpi_stm32.h,196 :: 		FT5XX6_SetDefaultMode( );
BL	_FT5XX6_SetDefaultMode+0
;mmb_4_fpi_stm32.h,197 :: 		FT5XX6_SetController( _TC_FT5X16 );
MOVS	R0, #2
BL	_FT5XX6_SetController+0
;mmb_4_fpi_stm32.h,198 :: 		FT5XX6_SetSizeAndRotation( 480, 272, 0 );
MOVS	R2, #0
MOVW	R1, #272
MOVW	R0, #480
BL	_FT5XX6_SetSizeAndRotation+0
;mmb_4_fpi_stm32.h,200 :: 		return FT5XX6_OK;
MOVS	R0, #0
;mmb_4_fpi_stm32.h,201 :: 		}
L_end_hal_touch_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_touch_init
bsp_flash_driver_hal_console_init:
;mmb_4_fpi_stm32.h,213 :: 		static void hal_console_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,222 :: 		&_GPIO_MODULE_USART2_PD5_PA3
MOVW	R0, #lo_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
PUSH	(R0)
;mmb_4_fpi_stm32.h,221 :: 		_UART_ONE_STOPBIT,
MOVW	R3, #0
;mmb_4_fpi_stm32.h,220 :: 		_UART_NOPARITY,
MOVW	R2, #0
;mmb_4_fpi_stm32.h,219 :: 		_UART_8_BIT_DATA,
MOVW	R1, #0
;mmb_4_fpi_stm32.h,218 :: 		115200,
MOV	R0, #115200
;mmb_4_fpi_stm32.h,222 :: 		&_GPIO_MODULE_USART2_PD5_PA3
BL	_UART2_Init_Advanced+0
ADD	SP, SP, #4
;mmb_4_fpi_stm32.h,224 :: 		}
L_end_hal_console_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_console_init
bsp_flash_driver_hal_power_init:
;mmb_4_fpi_stm32.h,257 :: 		static void hal_power_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,261 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_1 );
MOVW	R1, #2
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,265 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_12 );
MOVW	R1, #4096
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,269 :: 		GPIO_Analog_Input( &GPIOC_BASE, _GPIO_PINMASK_3 );
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOC_BASE+0)
MOVT	R0, #hi_addr(GPIOC_BASE+0)
BL	_GPIO_Analog_Input+0
;mmb_4_fpi_stm32.h,273 :: 		ADC_Set_Input_Channel( _ADC_CHANNEL_13 );
MOVW	R0, #8192
BL	_ADC_Set_Input_Channel+0
;mmb_4_fpi_stm32.h,275 :: 		ADC3_Init( );
BL	_ADC3_Init+0
;mmb_4_fpi_stm32.h,276 :: 		}
L_end_hal_power_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_power_init
bsp_flash_driver_hal_microsd_init:
;mmb_4_fpi_stm32.h,294 :: 		static void hal_microsd_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,317 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_3 );   // SD_CD
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,318 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_2 );  // SD_CMD
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,320 :: 		SDIO_Reset( );
BL	_SDIO_Reset+0
;mmb_4_fpi_stm32.h,323 :: 		| _SDIO_CFG_CLOCK_RISING_EDGE  | _SDIO_CFG_HW_FLOW_DISABLE, 125, &_GPIO_MODULE_SDIO_D0_D3 );
MOVW	R2, #lo_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVS	R1, #125
MOV	R0, #2048
BL	_SDIO_Init+0
;mmb_4_fpi_stm32.h,326 :: 		GPIOD_PUPDRbits.PUPDR2  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOD_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOD_PUPDRbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #2
STRB	R0, [R1, #0]
;mmb_4_fpi_stm32.h,327 :: 		GPIOC_PUPDRbits.PUPDR8  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #16, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,328 :: 		GPIOC_PUPDRbits.PUPDR9  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #18, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,329 :: 		GPIOC_PUPDRbits.PUPDR10 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #20, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,330 :: 		GPIOC_PUPDRbits.PUPDR11 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #22, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,332 :: 		Mmc_Set_Interface( _MMC_INTERFACE_SDIO );
MOVS	R0, #1
BL	_Mmc_Set_Interface+0
;mmb_4_fpi_stm32.h,335 :: 		}
L_end_hal_microsd_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_microsd_init
bsp_flash_driver_hal_flash_init:
;mmb_4_fpi_stm32.h,353 :: 		static void hal_flash_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,357 :: 		GPIO_Digital_Output( &GPIOC_BASE, _GPIO_PINMASK_13 );
MOVW	R1, #8192
MOVW	R0, #lo_addr(GPIOC_BASE+0)
MOVT	R0, #hi_addr(GPIOC_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,371 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_4_fpi_stm32.h,370 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_4_fpi_stm32.h,362 :: 		_SPI_FPCLK_DIV32,
MOVS	R0, #4
;mmb_4_fpi_stm32.h,371 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_4_fpi_stm32.h,374 :: 		BSP_FLASH_CE = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
_SX	[R0, ByteOffset(GPIOC_ODR+0)]
;mmb_4_fpi_stm32.h,375 :: 		}
L_end_hal_flash_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_flash_init
bsp_flash_driver_hal_rf_init:
;mmb_4_fpi_stm32.h,466 :: 		static void hal_rf_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,470 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_0 );
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,474 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_13 );
MOVW	R1, #8192
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,478 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_4 );
MOVW	R1, #16
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,492 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_4_fpi_stm32.h,491 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_4_fpi_stm32.h,483 :: 		_SPI_FPCLK_DIV16,
MOVS	R0, #3
;mmb_4_fpi_stm32.h,492 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_4_fpi_stm32.h,494 :: 		}
L_end_hal_rf_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_rf_init
bsp_flash_driver_hal_mp3_init:
;mmb_4_fpi_stm32.h,514 :: 		static void hal_mp3_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,518 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,522 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_3 );
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,526 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,530 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_10 );
MOVW	R1, #1024
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,544 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_4_fpi_stm32.h,543 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_4_fpi_stm32.h,535 :: 		_SPI_FPCLK_DIV256,
MOVS	R0, #7
;mmb_4_fpi_stm32.h,544 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_4_fpi_stm32.h,546 :: 		}
L_end_hal_mp3_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_mp3_init
bsp_flash_driver_hal_accel_init:
;mmb_4_fpi_stm32.h,566 :: 		static void hal_accel_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,570 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,574 :: 		GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_2 );
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOF_BASE+0)
MOVT	R0, #hi_addr(GPIOF_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,578 :: 		I2C1_Init_Advanced( 100000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #34464
MOVT	R0, #1
BL	_I2C1_Init_Advanced+0
;mmb_4_fpi_stm32.h,579 :: 		}
L_end_hal_accel_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_accel_init
bsp_flash_driver_hal_buzzer_init:
;mmb_4_fpi_stm32.h,701 :: 		static void hal_buzzer_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,705 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,709 :: 		Sound_Init( &GPIOB_ODR, 8 );
MOVS	R1, #8
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
BL	_Sound_Init+0
;mmb_4_fpi_stm32.h,710 :: 		}
L_end_hal_buzzer_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_buzzer_init
bsp_flash_driver_hal_rtc_init:
;mmb_4_fpi_stm32.h,733 :: 		static void hal_rtc_init ( void )
;mmb_4_fpi_stm32.h,739 :: 		RCC_APB1ENR.PWREN = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_APB1ENR+0)
MOVT	R0, #hi_addr(RCC_APB1ENR+0)
_SX	[R0, ByteOffset(RCC_APB1ENR+0)]
;mmb_4_fpi_stm32.h,741 :: 		if ( RCC_BDCR.RTCEN == 0 )
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_bsp_flash_driver_hal_rtc_init16
;mmb_4_fpi_stm32.h,745 :: 		PWR_CR.DBP = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PWR_CR+0)
MOVT	R0, #hi_addr(PWR_CR+0)
_SX	[R0, ByteOffset(PWR_CR+0)]
;mmb_4_fpi_stm32.h,749 :: 		RTC_WPR = 0xCA;
MOVS	R1, #202
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,750 :: 		RTC_WPR = 0x53;
MOVS	R1, #83
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,758 :: 		RCC_BDCR = 0x00010000;
MOV	R1, #65536
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,759 :: 		RCC_BDCR = 0x00008101;
MOVW	R1, #33025
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,760 :: 		}
L_bsp_flash_driver_hal_rtc_init16:
;mmb_4_fpi_stm32.h,764 :: 		while ( RTC_ISR.RSF != 1 )
L_bsp_flash_driver_hal_rtc_init17:
MOVW	R0, #lo_addr(RTC_ISR+0)
MOVT	R0, #hi_addr(RTC_ISR+0)
_LX	[R0, ByteOffset(RTC_ISR+0)]
CMP	R0, #0
IT	NE
BNE	L_bsp_flash_driver_hal_rtc_init18
;mmb_4_fpi_stm32.h,767 :: 		}
IT	AL
BAL	L_bsp_flash_driver_hal_rtc_init17
L_bsp_flash_driver_hal_rtc_init18:
;mmb_4_fpi_stm32.h,771 :: 		while ( RCC_BDCR.LSERDY != 1 )
L_bsp_flash_driver_hal_rtc_init19:
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_bsp_flash_driver_hal_rtc_init20
;mmb_4_fpi_stm32.h,774 :: 		}
IT	AL
BAL	L_bsp_flash_driver_hal_rtc_init19
L_bsp_flash_driver_hal_rtc_init20:
;mmb_4_fpi_stm32.h,776 :: 		RTC_WPR = 0xFF;
MOVS	R1, #255
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,777 :: 		}
L_end_hal_rtc_init:
BX	LR
; end of bsp_flash_driver_hal_rtc_init
bsp_flash_driver_hal_usb_init:
;mmb_4_fpi_stm32.h,791 :: 		static void hal_usb_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,795 :: 		GPIO_Alternate_Function_Enable( &_GPIO_MODULE_OTG_FS_PA89_10_11_12 );
MOVW	R0, #lo_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
BL	_GPIO_Alternate_Function_Enable+0
;mmb_4_fpi_stm32.h,799 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,803 :: 		BSP_USB_PSW = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_4_fpi_stm32.h,804 :: 		Delay_ms( 100 );
MOVW	R7, #2302
MOVT	R7, #61
NOP
NOP
L_bsp_flash_driver_hal_usb_init21:
SUBS	R7, R7, #1
BNE	L_bsp_flash_driver_hal_usb_init21
NOP
NOP
NOP
;mmb_4_fpi_stm32.h,805 :: 		BSP_USB_PSW = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_4_fpi_stm32.h,806 :: 		}
L_end_hal_usb_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of bsp_flash_driver_hal_usb_init
_bsp_flash_instruction:
;bsp_flash_driver.c,66 :: 		void bsp_flash_instruction ( uint8_t instruction )
; instruction start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; instruction end address is: 0 (R0)
; instruction start address is: 0 (R0)
;bsp_flash_driver.c,68 :: 		uint8_t tmp = instruction;
STRB	R0, [SP, #4]
; instruction end address is: 0 (R0)
;bsp_flash_driver.c,70 :: 		CE_LO;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,71 :: 		hal_spi_write( &tmp, 1 );
ADD	R1, SP, #4
MOV	R0, R1
MOVS	R1, #1
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,72 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,73 :: 		}
L_end_bsp_flash_instruction:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _bsp_flash_instruction
_bsp_flash_set_config:
;bsp_flash_driver.c,75 :: 		void bsp_flash_set_config ( uint8_t cfg )
; cfg start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; cfg end address is: 0 (R0)
; cfg start address is: 0 (R0)
;bsp_flash_driver.c,79 :: 		tmp[0] = _BSP_FLASH_WRSR;
ADD	R3, SP, #4
MOVS	R1, #1
STRB	R1, [R3, #0]
;bsp_flash_driver.c,80 :: 		tmp[1] = 0;
ADDS	R2, R3, #1
MOVS	R1, #0
STRB	R1, [R2, #0]
;bsp_flash_driver.c,81 :: 		tmp[2] = cfg;
ADDS	R1, R3, #2
STRB	R0, [R1, #0]
; cfg end address is: 0 (R0)
;bsp_flash_driver.c,83 :: 		bsp_flash_instruction( _BSP_FLASH_WREN );
MOVS	R0, #6
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,85 :: 		CE_LO;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,86 :: 		hal_spi_write( tmp, 3 );
ADD	R1, SP, #4
MOV	R0, R1
MOVS	R1, #3
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,87 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,88 :: 		}
L_end_bsp_flash_set_config:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _bsp_flash_set_config
_bsp_flash_get_config:
;bsp_flash_driver.c,90 :: 		uint8_t bsp_flash_get_config ( void )
SUB	SP, SP, #8
STR	LR, [SP, #0]
;bsp_flash_driver.c,92 :: 		uint8_t tmp = _BSP_FLASH_RDCR;
MOVS	R0, #53
STRB	R0, [SP, #4]
;bsp_flash_driver.c,94 :: 		CE_LO;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
_SX	[R0, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,95 :: 		hal_spi_write( &tmp, 1 );
ADD	R0, SP, #4
MOVS	R1, #1
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,96 :: 		hal_spi_read( &tmp, 1 );
ADD	R0, SP, #4
MOVS	R1, #1
BL	bsp_flash_driver_hal_spi_read+0
;bsp_flash_driver.c,97 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
_SX	[R0, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,99 :: 		return tmp;
LDRB	R0, [SP, #4]
;bsp_flash_driver.c,100 :: 		}
L_end_bsp_flash_get_config:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _bsp_flash_get_config
_bsp_flash_get_status:
;bsp_flash_driver.c,102 :: 		uint8_t bsp_flash_get_status ( void )
SUB	SP, SP, #8
STR	LR, [SP, #0]
;bsp_flash_driver.c,104 :: 		uint8_t tmp = _BSP_FLASH_RDSR;
MOVS	R0, #5
STRB	R0, [SP, #4]
;bsp_flash_driver.c,106 :: 		CE_LO;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
_SX	[R0, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,107 :: 		hal_spi_write( &tmp, 1 );
ADD	R0, SP, #4
MOVS	R1, #1
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,108 :: 		hal_spi_read( &tmp, 1 );
ADD	R0, SP, #4
MOVS	R1, #1
BL	bsp_flash_driver_hal_spi_read+0
;bsp_flash_driver.c,109 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
_SX	[R0, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,111 :: 		return tmp;
LDRB	R0, [SP, #4]
;bsp_flash_driver.c,112 :: 		}
L_end_bsp_flash_get_status:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _bsp_flash_get_status
_bsp_flash_init:
;bsp_flash_driver.c,114 :: 		flash_rc_t bsp_flash_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;bsp_flash_driver.c,118 :: 		hal_spi_map( &BSP_FLASH_SPI_MODULE );
MOVW	R0, #lo_addr(bsp_flash_driver_BSP_FLASH_SPI_MODULE+0)
MOVT	R0, #hi_addr(bsp_flash_driver_BSP_FLASH_SPI_MODULE+0)
BL	bsp_flash_driver_hal_spi_map+0
;bsp_flash_driver.c,119 :: 		hal_flash_init( );
BL	bsp_flash_driver_hal_flash_init+0
;bsp_flash_driver.c,128 :: 		bsp_flash_instruction( _BSP_FLASH_RSTEN );
MOVS	R0, #102
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,129 :: 		bsp_flash_instruction( _BSP_FLASH_RST );
MOVS	R0, #153
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,130 :: 		bsp_flash_instruction( _BSP_FLASH_WREN );
MOVS	R0, #6
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,131 :: 		bsp_flash_instruction( _BSP_FLASH_ULBPR );
MOVS	R0, #152
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,133 :: 		rc =  wait_while_busy( FLASH_INIT_TIMEOUT );
MOVW	R0, #2000
BL	bsp_flash_driver_wait_while_busy+0
;bsp_flash_driver.c,135 :: 		return rc;
UXTB	R0, R0
;bsp_flash_driver.c,136 :: 		}
L_end_bsp_flash_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _bsp_flash_init
_bsp_flash_sector_erase:
;bsp_flash_driver.c,138 :: 		flash_rc_t bsp_flash_sector_erase ( uint32_t address )
; address start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; address end address is: 0 (R0)
; address start address is: 0 (R0)
;bsp_flash_driver.c,143 :: 		tmp[0] = _BSP_FLASH_SE;
ADD	R3, SP, #4
MOVS	R1, #32
STRB	R1, [R3, #0]
;bsp_flash_driver.c,144 :: 		tmp[1] = 0;
ADDS	R2, R3, #1
MOVS	R1, #0
STRB	R1, [R2, #0]
;bsp_flash_driver.c,145 :: 		tmp[2] = 0;
ADDS	R2, R3, #2
MOVS	R1, #0
STRB	R1, [R2, #0]
;bsp_flash_driver.c,146 :: 		tmp[3] = 0;
ADDS	R2, R3, #3
MOVS	R1, #0
STRB	R1, [R2, #0]
;bsp_flash_driver.c,148 :: 		if ( ( rc = address_convert( address, &tmp[1] ) ) == FLASH_OK )
ADDS	R1, R3, #1
; address end address is: 0 (R0)
BL	bsp_flash_driver_address_convert+0
; rc start address is: 8 (R2)
UXTB	R2, R0
UXTB	R1, R0
CMP	R1, #0
IT	NE
BNE	L__bsp_flash_sector_erase39
; rc end address is: 8 (R2)
;bsp_flash_driver.c,150 :: 		bsp_flash_instruction( _BSP_FLASH_WREN );
MOVS	R0, #6
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,152 :: 		CE_LO;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,153 :: 		hal_spi_write( tmp, 4 );
ADD	R1, SP, #4
MOV	R0, R1
MOVS	R1, #4
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,154 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,156 :: 		rc =  wait_while_busy( SECTOR_ERASE_TIMEOUT );
MOVW	R0, #10000
BL	bsp_flash_driver_wait_while_busy+0
; rc start address is: 4 (R1)
UXTB	R1, R0
; rc end address is: 4 (R1)
UXTB	R0, R1
;bsp_flash_driver.c,157 :: 		}
IT	AL
BAL	L_bsp_flash_sector_erase23
L__bsp_flash_sector_erase39:
;bsp_flash_driver.c,148 :: 		if ( ( rc = address_convert( address, &tmp[1] ) ) == FLASH_OK )
UXTB	R0, R2
;bsp_flash_driver.c,157 :: 		}
L_bsp_flash_sector_erase23:
;bsp_flash_driver.c,159 :: 		return rc;
; rc start address is: 0 (R0)
; rc end address is: 0 (R0)
;bsp_flash_driver.c,160 :: 		}
L_end_bsp_flash_sector_erase:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _bsp_flash_sector_erase
_bsp_flash_block_erase:
;bsp_flash_driver.c,162 :: 		flash_rc_t bsp_flash_block_erase ( uint32_t address )
; address start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; address end address is: 0 (R0)
; address start address is: 0 (R0)
;bsp_flash_driver.c,167 :: 		tmp[0] = _BSP_FLASH_BE;
ADD	R3, SP, #4
MOVS	R1, #216
STRB	R1, [R3, #0]
;bsp_flash_driver.c,168 :: 		tmp[1] = 0;
ADDS	R2, R3, #1
MOVS	R1, #0
STRB	R1, [R2, #0]
;bsp_flash_driver.c,169 :: 		tmp[2] = 0;
ADDS	R2, R3, #2
MOVS	R1, #0
STRB	R1, [R2, #0]
;bsp_flash_driver.c,170 :: 		tmp[3] = 0;
ADDS	R2, R3, #3
MOVS	R1, #0
STRB	R1, [R2, #0]
;bsp_flash_driver.c,172 :: 		if ( ( rc = address_convert( address, &tmp[1] ) ) == FLASH_OK )
ADDS	R1, R3, #1
; address end address is: 0 (R0)
BL	bsp_flash_driver_address_convert+0
; rc start address is: 8 (R2)
UXTB	R2, R0
UXTB	R1, R0
CMP	R1, #0
IT	NE
BNE	L__bsp_flash_block_erase40
; rc end address is: 8 (R2)
;bsp_flash_driver.c,174 :: 		bsp_flash_instruction( _BSP_FLASH_WREN );
MOVS	R0, #6
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,176 :: 		CE_LO;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,177 :: 		hal_spi_write( tmp, 4 );
ADD	R1, SP, #4
MOV	R0, R1
MOVS	R1, #4
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,178 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOC_ODR+0)
MOVT	R1, #hi_addr(GPIOC_ODR+0)
_SX	[R1, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,180 :: 		rc =  wait_while_busy( BLOCK_ERASE_TIMEOUT );
MOVW	R0, #4000
BL	bsp_flash_driver_wait_while_busy+0
; rc start address is: 4 (R1)
UXTB	R1, R0
; rc end address is: 4 (R1)
UXTB	R0, R1
;bsp_flash_driver.c,181 :: 		}
IT	AL
BAL	L_bsp_flash_block_erase24
L__bsp_flash_block_erase40:
;bsp_flash_driver.c,172 :: 		if ( ( rc = address_convert( address, &tmp[1] ) ) == FLASH_OK )
UXTB	R0, R2
;bsp_flash_driver.c,181 :: 		}
L_bsp_flash_block_erase24:
;bsp_flash_driver.c,183 :: 		return rc;
; rc start address is: 0 (R0)
; rc end address is: 0 (R0)
;bsp_flash_driver.c,184 :: 		}
L_end_bsp_flash_block_erase:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _bsp_flash_block_erase
_bsp_flash_chip_erase:
;bsp_flash_driver.c,186 :: 		flash_rc_t bsp_flash_chip_erase ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;bsp_flash_driver.c,190 :: 		bsp_flash_instruction( _BSP_FLASH_WREN );
MOVS	R0, #6
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,191 :: 		bsp_flash_instruction( _BSP_FLASH_CE );
MOVS	R0, #199
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,193 :: 		rc =  wait_while_busy( CHIP_ERASE_TIMEOUT );
MOVW	R0, #2000
BL	bsp_flash_driver_wait_while_busy+0
;bsp_flash_driver.c,195 :: 		return rc;
UXTB	R0, R0
;bsp_flash_driver.c,196 :: 		}
L_end_bsp_flash_chip_erase:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _bsp_flash_chip_erase
_bsp_flash_write:
;bsp_flash_driver.c,198 :: 		flash_rc_t bsp_flash_write ( uint32_t address, uint8_t * _data, uint8_t len )
; address start address is: 0 (R0)
SUB	SP, SP, #20
STR	LR, [SP, #0]
STR	R1, [SP, #12]
STRB	R2, [SP, #16]
; address end address is: 0 (R0)
; address start address is: 0 (R0)
;bsp_flash_driver.c,203 :: 		tmp[0] = _BSP_FLASH_PP;
ADD	R5, SP, #4
MOVS	R3, #2
STRB	R3, [R5, #0]
;bsp_flash_driver.c,204 :: 		tmp[1] = 0;
ADDS	R4, R5, #1
MOVS	R3, #0
STRB	R3, [R4, #0]
;bsp_flash_driver.c,205 :: 		tmp[2] = 0;
ADDS	R4, R5, #2
MOVS	R3, #0
STRB	R3, [R4, #0]
;bsp_flash_driver.c,206 :: 		tmp[3] = 0;
ADDS	R4, R5, #3
MOVS	R3, #0
STRB	R3, [R4, #0]
;bsp_flash_driver.c,208 :: 		if ( ( rc = address_convert( address, &tmp[1] ) ) == FLASH_OK )
ADDS	R3, R5, #1
MOV	R1, R3
; address end address is: 0 (R0)
BL	bsp_flash_driver_address_convert+0
STRB	R0, [SP, #8]
UXTB	R3, R0
CMP	R3, #0
IT	NE
BNE	L_bsp_flash_write25
;bsp_flash_driver.c,210 :: 		bsp_flash_instruction( _BSP_FLASH_WREN );
MOVS	R0, #6
BL	_bsp_flash_instruction+0
;bsp_flash_driver.c,212 :: 		CE_LO;
MOVS	R4, #0
SXTB	R4, R4
MOVW	R3, #lo_addr(GPIOC_ODR+0)
MOVT	R3, #hi_addr(GPIOC_ODR+0)
_SX	[R3, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,213 :: 		hal_spi_write( tmp, 4 );                                                //  Write instruction and address
ADD	R3, SP, #4
MOVS	R1, #4
MOV	R0, R3
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,214 :: 		hal_spi_write( _data, ( uint16_t ) len );                               //  Write data.
LDRB	R3, [SP, #16]
UXTH	R1, R3
LDR	R0, [SP, #12]
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,215 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R4, #1
SXTB	R4, R4
MOVW	R3, #lo_addr(GPIOC_ODR+0)
MOVT	R3, #hi_addr(GPIOC_ODR+0)
_SX	[R3, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,217 :: 		rc =  wait_while_busy( PAGE_WRITE_TIMEOUT );
MOVW	R0, #2000
BL	bsp_flash_driver_wait_while_busy+0
STRB	R0, [SP, #8]
;bsp_flash_driver.c,218 :: 		}
L_bsp_flash_write25:
;bsp_flash_driver.c,220 :: 		return rc;
LDRB	R0, [SP, #8]
;bsp_flash_driver.c,221 :: 		}
L_end_bsp_flash_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _bsp_flash_write
_bsp_flash_read:
;bsp_flash_driver.c,223 :: 		flash_rc_t bsp_flash_read ( uint32_t address, uint8_t * _data, uint8_t len )
; address start address is: 0 (R0)
SUB	SP, SP, #20
STR	LR, [SP, #0]
STR	R1, [SP, #12]
STRB	R2, [SP, #16]
; address end address is: 0 (R0)
; address start address is: 0 (R0)
;bsp_flash_driver.c,228 :: 		tmp[0] = _BSP_FLASH_READ;
ADD	R5, SP, #4
MOVS	R3, #3
STRB	R3, [R5, #0]
;bsp_flash_driver.c,229 :: 		tmp[1] = 0;
ADDS	R4, R5, #1
MOVS	R3, #0
STRB	R3, [R4, #0]
;bsp_flash_driver.c,230 :: 		tmp[2] = 0;
ADDS	R4, R5, #2
MOVS	R3, #0
STRB	R3, [R4, #0]
;bsp_flash_driver.c,231 :: 		tmp[3] = 0;
ADDS	R4, R5, #3
MOVS	R3, #0
STRB	R3, [R4, #0]
;bsp_flash_driver.c,233 :: 		if ( ( rc = address_convert( address, &tmp[1] ) ) == FLASH_OK )
ADDS	R3, R5, #1
MOV	R1, R3
; address end address is: 0 (R0)
BL	bsp_flash_driver_address_convert+0
STRB	R0, [SP, #8]
UXTB	R3, R0
CMP	R3, #0
IT	NE
BNE	L_bsp_flash_read26
;bsp_flash_driver.c,235 :: 		CE_LO;
MOVS	R4, #0
SXTB	R4, R4
MOVW	R3, #lo_addr(GPIOC_ODR+0)
MOVT	R3, #hi_addr(GPIOC_ODR+0)
_SX	[R3, ByteOffset(GPIOC_ODR+0)]
BL	_Delay_1us+0
;bsp_flash_driver.c,236 :: 		hal_spi_write( tmp, 4 );                                                //  Write instruction and address
ADD	R3, SP, #4
MOVS	R1, #4
MOV	R0, R3
BL	bsp_flash_driver_hal_spi_write+0
;bsp_flash_driver.c,237 :: 		hal_spi_read( _data, ( uint16_t ) len );                                //  Read data.
LDRB	R3, [SP, #16]
UXTH	R1, R3
LDR	R0, [SP, #12]
BL	bsp_flash_driver_hal_spi_read+0
;bsp_flash_driver.c,238 :: 		CE_HI;
BL	_Delay_1us+0
MOVS	R4, #1
SXTB	R4, R4
MOVW	R3, #lo_addr(GPIOC_ODR+0)
MOVT	R3, #hi_addr(GPIOC_ODR+0)
_SX	[R3, ByteOffset(GPIOC_ODR+0)]
;bsp_flash_driver.c,239 :: 		}
L_bsp_flash_read26:
;bsp_flash_driver.c,241 :: 		return rc;
LDRB	R0, [SP, #8]
;bsp_flash_driver.c,242 :: 		}
L_end_bsp_flash_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _bsp_flash_read
bsp_flash_driver_address_convert:
;bsp_flash_driver.c,246 :: 		static int address_convert ( uint32_t address, uint8_t * arr )
; arr start address is: 4 (R1)
; address start address is: 0 (R0)
; arr end address is: 4 (R1)
; address end address is: 0 (R0)
; address start address is: 0 (R0)
; arr start address is: 4 (R1)
;bsp_flash_driver.c,248 :: 		if ( ( address < START_PAGE_ADDRESS ) || ( address > END_PAGE_ADDRESS ) )
CMP	R0, #65536
IT	CC
BCC	L_bsp_flash_driver_address_convert38
MOVW	R2, #65535
MOVT	R2, #127
CMP	R0, R2
IT	HI
BHI	L_bsp_flash_driver_address_convert37
IT	AL
BAL	L_bsp_flash_driver_address_convert29
; address end address is: 0 (R0)
; arr end address is: 4 (R1)
L_bsp_flash_driver_address_convert38:
L_bsp_flash_driver_address_convert37:
;bsp_flash_driver.c,250 :: 		return FLASH_ERROR;
MOVS	R0, #1
SXTH	R0, R0
IT	AL
BAL	L_end_address_convert
;bsp_flash_driver.c,251 :: 		}
L_bsp_flash_driver_address_convert29:
;bsp_flash_driver.c,253 :: 		arr[0] = ( uint8_t ) ( ( address & 0x00FF0000 ) >> 16 );
; arr start address is: 4 (R1)
; address start address is: 0 (R0)
AND	R2, R0, #16711680
LSRS	R2, R2, #16
UXTB	R2, R2
STRB	R2, [R1, #0]
;bsp_flash_driver.c,254 :: 		arr[1] = ( uint8_t ) ( ( address & 0x0000FF00 ) >> 8 );
ADDS	R3, R1, #1
AND	R2, R0, #65280
LSRS	R2, R2, #8
UXTB	R2, R2
STRB	R2, [R3, #0]
;bsp_flash_driver.c,255 :: 		arr[2] = ( uint8_t )   ( address & 0x000000FF );
ADDS	R3, R1, #2
; arr end address is: 4 (R1)
AND	R2, R0, #255
; address end address is: 0 (R0)
UXTB	R2, R2
STRB	R2, [R3, #0]
;bsp_flash_driver.c,257 :: 		return FLASH_OK;
MOVS	R0, #0
SXTH	R0, R0
;bsp_flash_driver.c,258 :: 		}
L_end_address_convert:
BX	LR
; end of bsp_flash_driver_address_convert
bsp_flash_driver_wait_while_busy:
;bsp_flash_driver.c,260 :: 		static int wait_while_busy ( uint32_t cyc )
SUB	SP, SP, #12
STR	LR, [SP, #0]
STR	R0, [SP, #8]
;bsp_flash_driver.c,262 :: 		uint32_t wd = 0;
MOV	R1, #0
STR	R1, [SP, #4]
;bsp_flash_driver.c,264 :: 		while ( FLASH_BUSY )
L_bsp_flash_driver_wait_while_busy30:
BL	_bsp_flash_get_status+0
AND	R1, R0, #1
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_bsp_flash_driver_wait_while_busy31
;bsp_flash_driver.c,268 :: 		Delay_1ms( );
BL	_Delay_1ms+0
;bsp_flash_driver.c,270 :: 		if ( ++wd > cyc )
LDR	R1, [SP, #4]
ADDS	R2, R1, #1
STR	R2, [SP, #4]
LDR	R1, [SP, #8]
CMP	R2, R1
IT	LS
BLS	L_bsp_flash_driver_wait_while_busy32
;bsp_flash_driver.c,274 :: 		return FLASH_ERROR;
MOVS	R0, #1
SXTH	R0, R0
IT	AL
BAL	L_end_wait_while_busy
;bsp_flash_driver.c,275 :: 		}
L_bsp_flash_driver_wait_while_busy32:
;bsp_flash_driver.c,276 :: 		}
IT	AL
BAL	L_bsp_flash_driver_wait_while_busy30
L_bsp_flash_driver_wait_while_busy31:
;bsp_flash_driver.c,278 :: 		return FLASH_OK;
MOVS	R0, #0
SXTH	R0, R0
;bsp_flash_driver.c,279 :: 		}
L_end_wait_while_busy:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of bsp_flash_driver_wait_while_busy
