netcfg_Write_to_Data_Lines:
;mmb_4_fpi_stm32.h,86 :: 		static void Write_to_Data_Lines ( unsigned char _hi, unsigned char _lo )
; _lo start address is: 4 (R1)
; _hi start address is: 0 (R0)
; _lo end address is: 4 (R1)
; _hi end address is: 0 (R0)
; _hi start address is: 0 (R0)
; _lo start address is: 4 (R1)
;mmb_4_fpi_stm32.h,88 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 12 (R3)
LDR	R3, [R2, #0]
;mmb_4_fpi_stm32.h,89 :: 		tmp &= 0xFF00;
AND	R2, R3, #65280
UXTH	R2, R2
; tmp end address is: 12 (R3)
;mmb_4_fpi_stm32.h,90 :: 		GPIOE_ODR = tmp | _hi;
ORR	R3, R2, R0, LSL #0
UXTH	R3, R3
; _hi end address is: 0 (R0)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_4_fpi_stm32.h,91 :: 		tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 0 (R0)
LDR	R0, [R2, #0]
;mmb_4_fpi_stm32.h,92 :: 		tmp &= 0xFF00;
AND	R2, R0, #65280
UXTH	R2, R2
; tmp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,93 :: 		GPIOE_ODR = tmp | _lo;
ORR	R3, R2, R1, LSL #0
UXTH	R3, R3
; _lo end address is: 4 (R1)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_4_fpi_stm32.h,94 :: 		}
L_end_Write_to_Data_Lines:
BX	LR
; end of netcfg_Write_to_Data_Lines
netcfg_Write_to_Data_Lines_8bit:
;mmb_4_fpi_stm32.h,96 :: 		static void Write_to_Data_Lines_8bit ( unsigned char _data )
; _data start address is: 0 (R0)
; _data end address is: 0 (R0)
; _data start address is: 0 (R0)
;mmb_4_fpi_stm32.h,98 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 8 (R2)
LDR	R2, [R1, #0]
;mmb_4_fpi_stm32.h,99 :: 		tmp &= 0xFF00;
AND	R1, R2, #65280
UXTH	R1, R1
; tmp end address is: 8 (R2)
;mmb_4_fpi_stm32.h,100 :: 		GPIOE_ODR = tmp | _data;
ORR	R2, R1, R0, LSL #0
UXTH	R2, R2
; _data end address is: 0 (R0)
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
STR	R2, [R1, #0]
;mmb_4_fpi_stm32.h,101 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,102 :: 		asm nop;
NOP
;mmb_4_fpi_stm32.h,103 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,104 :: 		}
L_end_Write_to_Data_Lines_8bit:
BX	LR
; end of netcfg_Write_to_Data_Lines_8bit
netcfg_Set_Index:
;mmb_4_fpi_stm32.h,106 :: 		static void Set_Index ( unsigned short index )
; index start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; index end address is: 0 (R0)
; index start address is: 0 (R0)
;mmb_4_fpi_stm32.h,108 :: 		TFT_RS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_4_fpi_stm32.h,109 :: 		Write_to_Data_Lines(0, index);
UXTB	R1, R0
; index end address is: 0 (R0)
MOVS	R0, #0
BL	netcfg_Write_to_Data_Lines+0
;mmb_4_fpi_stm32.h,110 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,111 :: 		asm nop;
NOP
;mmb_4_fpi_stm32.h,112 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,113 :: 		}
L_end_Set_Index:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_Set_Index
netcfg_Write_Command:
;mmb_4_fpi_stm32.h,115 :: 		static void Write_Command ( unsigned short cmd )
; cmd start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; cmd end address is: 0 (R0)
; cmd start address is: 0 (R0)
;mmb_4_fpi_stm32.h,117 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_4_fpi_stm32.h,118 :: 		Write_to_Data_Lines(0, cmd);
UXTB	R1, R0
; cmd end address is: 0 (R0)
MOVS	R0, #0
BL	netcfg_Write_to_Data_Lines+0
;mmb_4_fpi_stm32.h,119 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,120 :: 		asm nop;
NOP
;mmb_4_fpi_stm32.h,121 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_4_fpi_stm32.h,122 :: 		}
L_end_Write_Command:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_Write_Command
netcfg_Write_Data:
;mmb_4_fpi_stm32.h,124 :: 		static void Write_Data ( unsigned int _data )
; _data start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
UXTH	R3, R0
; _data end address is: 0 (R0)
; _data start address is: 12 (R3)
;mmb_4_fpi_stm32.h,128 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_4_fpi_stm32.h,129 :: 		temp = (_data>>11);
LSRS	R1, R3, #11
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_4_fpi_stm32.h,130 :: 		temp = (temp<<3);
LSLS	R1, R0, #3
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_4_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_netcfg_Write_Data17
;mmb_4_fpi_stm32.h,134 :: 		temp += 7;
ADDS	R1, R4, #7
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,135 :: 		}
IT	AL
BAL	L_netcfg_Write_Data0
L_netcfg_Write_Data17:
;mmb_4_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_4_fpi_stm32.h,135 :: 		}
L_netcfg_Write_Data0:
;mmb_4_fpi_stm32.h,137 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	netcfg_Write_to_Data_Lines_8bit+0
;mmb_4_fpi_stm32.h,138 :: 		temp = (_data>>5);
LSRS	R1, R3, #5
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_4_fpi_stm32.h,139 :: 		temp = (temp<<2);
LSLS	R1, R0, #2
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_4_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_netcfg_Write_Data18
;mmb_4_fpi_stm32.h,143 :: 		temp += 3;
ADDS	R1, R4, #3
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,144 :: 		}
IT	AL
BAL	L_netcfg_Write_Data1
L_netcfg_Write_Data18:
;mmb_4_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_4_fpi_stm32.h,144 :: 		}
L_netcfg_Write_Data1:
;mmb_4_fpi_stm32.h,146 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	netcfg_Write_to_Data_Lines_8bit+0
;mmb_4_fpi_stm32.h,147 :: 		temp = (_data<<3);
LSLS	R1, R3, #3
; _data end address is: 12 (R3)
; temp start address is: 12 (R3)
UXTB	R3, R1
;mmb_4_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
LSRS	R1, R3, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_netcfg_Write_Data19
;mmb_4_fpi_stm32.h,151 :: 		temp += 7;
ADDS	R1, R3, #7
; temp end address is: 12 (R3)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_4_fpi_stm32.h,152 :: 		}
IT	AL
BAL	L_netcfg_Write_Data2
L_netcfg_Write_Data19:
;mmb_4_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
UXTB	R0, R3
;mmb_4_fpi_stm32.h,152 :: 		}
L_netcfg_Write_Data2:
;mmb_4_fpi_stm32.h,154 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	netcfg_Write_to_Data_Lines_8bit+0
;mmb_4_fpi_stm32.h,155 :: 		}
L_end_Write_Data:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_Write_Data
netcfg_hal_display_init:
;mmb_4_fpi_stm32.h,157 :: 		static void hal_display_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,161 :: 		TFT_Set_Active( Set_Index, Write_Command, Write_Data );
MOVW	R2, #lo_addr(netcfg_Write_Data+0)
MOVT	R2, #hi_addr(netcfg_Write_Data+0)
MOVW	R1, #lo_addr(netcfg_Write_Command+0)
MOVT	R1, #hi_addr(netcfg_Write_Command+0)
MOVW	R0, #lo_addr(netcfg_Set_Index+0)
MOVT	R0, #hi_addr(netcfg_Set_Index+0)
BL	_TFT_Set_Active+0
;mmb_4_fpi_stm32.h,162 :: 		TFT_Init_SSD1963_Board_43( 480, 272 );
MOVW	R1, #272
MOVW	R0, #480
BL	_TFT_Init_SSD1963_Board_43+0
;mmb_4_fpi_stm32.h,163 :: 		TFT_Set_DBC_SSD1963( 255 );
MOVS	R0, #255
BL	_TFT_Set_DBC_SSD1963+0
;mmb_4_fpi_stm32.h,164 :: 		}
L_end_hal_display_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_display_init
netcfg_hal_touch_init:
;mmb_4_fpi_stm32.h,170 :: 		static uint8_t hal_touch_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,174 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,175 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_7 );
MOVW	R1, #128
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,177 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_4_fpi_stm32.h,179 :: 		while (GPIOB_IDR.B7 == 0)
L_netcfg_hal_touch_init3:
MOVW	R0, #lo_addr(GPIOB_IDR+0)
MOVT	R0, #hi_addr(GPIOB_IDR+0)
_LX	[R0, ByteOffset(GPIOB_IDR+0)]
CMP	R0, #0
IT	NE
BNE	L_netcfg_hal_touch_init4
;mmb_4_fpi_stm32.h,181 :: 		GPIOB_ODR.B6 = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_4_fpi_stm32.h,182 :: 		Delay_us(10);
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_netcfg_hal_touch_init5:
SUBS	R7, R7, #1
BNE	L_netcfg_hal_touch_init5
NOP
NOP
NOP
;mmb_4_fpi_stm32.h,183 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_4_fpi_stm32.h,184 :: 		Delay_us(10);
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_netcfg_hal_touch_init7:
SUBS	R7, R7, #1
BNE	L_netcfg_hal_touch_init7
NOP
NOP
NOP
;mmb_4_fpi_stm32.h,185 :: 		}
IT	AL
BAL	L_netcfg_hal_touch_init3
L_netcfg_hal_touch_init4:
;mmb_4_fpi_stm32.h,187 :: 		I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #6784
MOVT	R0, #6
BL	_I2C1_Init_Advanced+0
;mmb_4_fpi_stm32.h,189 :: 		FT5XX6_SetI2CAddress( 0x38 );
MOVS	R0, #56
BL	_FT5XX6_SetI2CAddress+0
;mmb_4_fpi_stm32.h,191 :: 		if (FT5XX6_IsOperational( ) != FT5XX6_OK)
BL	_FT5XX6_IsOperational+0
CMP	R0, #0
IT	EQ
BEQ	L_netcfg_hal_touch_init9
;mmb_4_fpi_stm32.h,193 :: 		return  FT5XX6_FAILURE;
MOVS	R0, #1
IT	AL
BAL	L_end_hal_touch_init
;mmb_4_fpi_stm32.h,194 :: 		}
L_netcfg_hal_touch_init9:
;mmb_4_fpi_stm32.h,196 :: 		FT5XX6_SetDefaultMode( );
BL	_FT5XX6_SetDefaultMode+0
;mmb_4_fpi_stm32.h,197 :: 		FT5XX6_SetController( _TC_FT5X16 );
MOVS	R0, #2
BL	_FT5XX6_SetController+0
;mmb_4_fpi_stm32.h,198 :: 		FT5XX6_SetSizeAndRotation( 480, 272, 0 );
MOVS	R2, #0
MOVW	R1, #272
MOVW	R0, #480
BL	_FT5XX6_SetSizeAndRotation+0
;mmb_4_fpi_stm32.h,200 :: 		return FT5XX6_OK;
MOVS	R0, #0
;mmb_4_fpi_stm32.h,201 :: 		}
L_end_hal_touch_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_touch_init
netcfg_hal_console_init:
;mmb_4_fpi_stm32.h,213 :: 		static void hal_console_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,222 :: 		&_GPIO_MODULE_USART2_PD5_PA3
MOVW	R0, #lo_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
PUSH	(R0)
;mmb_4_fpi_stm32.h,221 :: 		_UART_ONE_STOPBIT,
MOVW	R3, #0
;mmb_4_fpi_stm32.h,220 :: 		_UART_NOPARITY,
MOVW	R2, #0
;mmb_4_fpi_stm32.h,219 :: 		_UART_8_BIT_DATA,
MOVW	R1, #0
;mmb_4_fpi_stm32.h,218 :: 		115200,
MOV	R0, #115200
;mmb_4_fpi_stm32.h,222 :: 		&_GPIO_MODULE_USART2_PD5_PA3
BL	_UART2_Init_Advanced+0
ADD	SP, SP, #4
;mmb_4_fpi_stm32.h,224 :: 		}
L_end_hal_console_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_console_init
netcfg_hal_power_init:
;mmb_4_fpi_stm32.h,257 :: 		static void hal_power_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,261 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_1 );
MOVW	R1, #2
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,265 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_12 );
MOVW	R1, #4096
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,269 :: 		GPIO_Analog_Input( &GPIOC_BASE, _GPIO_PINMASK_3 );
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOC_BASE+0)
MOVT	R0, #hi_addr(GPIOC_BASE+0)
BL	_GPIO_Analog_Input+0
;mmb_4_fpi_stm32.h,273 :: 		ADC_Set_Input_Channel( _ADC_CHANNEL_13 );
MOVW	R0, #8192
BL	_ADC_Set_Input_Channel+0
;mmb_4_fpi_stm32.h,275 :: 		ADC3_Init( );
BL	_ADC3_Init+0
;mmb_4_fpi_stm32.h,276 :: 		}
L_end_hal_power_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_power_init
netcfg_hal_microsd_init:
;mmb_4_fpi_stm32.h,294 :: 		static void hal_microsd_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,317 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_3 );   // SD_CD
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,318 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_2 );  // SD_CMD
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,320 :: 		SDIO_Reset( );
BL	_SDIO_Reset+0
;mmb_4_fpi_stm32.h,323 :: 		| _SDIO_CFG_CLOCK_RISING_EDGE  | _SDIO_CFG_HW_FLOW_DISABLE, 125, &_GPIO_MODULE_SDIO_D0_D3 );
MOVW	R2, #lo_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVS	R1, #125
MOV	R0, #2048
BL	_SDIO_Init+0
;mmb_4_fpi_stm32.h,326 :: 		GPIOD_PUPDRbits.PUPDR2  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOD_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOD_PUPDRbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #2
STRB	R0, [R1, #0]
;mmb_4_fpi_stm32.h,327 :: 		GPIOC_PUPDRbits.PUPDR8  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #16, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,328 :: 		GPIOC_PUPDRbits.PUPDR9  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #18, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,329 :: 		GPIOC_PUPDRbits.PUPDR10 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #20, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,330 :: 		GPIOC_PUPDRbits.PUPDR11 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #22, #2
STR	R0, [R1, #0]
;mmb_4_fpi_stm32.h,332 :: 		Mmc_Set_Interface( _MMC_INTERFACE_SDIO );
MOVS	R0, #1
BL	_Mmc_Set_Interface+0
;mmb_4_fpi_stm32.h,335 :: 		}
L_end_hal_microsd_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_microsd_init
netcfg_hal_flash_init:
;mmb_4_fpi_stm32.h,353 :: 		static void hal_flash_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,357 :: 		GPIO_Digital_Output( &GPIOC_BASE, _GPIO_PINMASK_13 );
MOVW	R1, #8192
MOVW	R0, #lo_addr(GPIOC_BASE+0)
MOVT	R0, #hi_addr(GPIOC_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,371 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_4_fpi_stm32.h,370 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_4_fpi_stm32.h,362 :: 		_SPI_FPCLK_DIV32,
MOVS	R0, #4
;mmb_4_fpi_stm32.h,371 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_4_fpi_stm32.h,374 :: 		BSP_FLASH_CE = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
_SX	[R0, ByteOffset(GPIOC_ODR+0)]
;mmb_4_fpi_stm32.h,375 :: 		}
L_end_hal_flash_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_flash_init
netcfg_hal_rf_init:
;mmb_4_fpi_stm32.h,466 :: 		static void hal_rf_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,470 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_0 );
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,474 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_13 );
MOVW	R1, #8192
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,478 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_4 );
MOVW	R1, #16
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,492 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_4_fpi_stm32.h,491 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_4_fpi_stm32.h,483 :: 		_SPI_FPCLK_DIV16,
MOVS	R0, #3
;mmb_4_fpi_stm32.h,492 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_4_fpi_stm32.h,494 :: 		}
L_end_hal_rf_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_rf_init
netcfg_hal_mp3_init:
;mmb_4_fpi_stm32.h,514 :: 		static void hal_mp3_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,518 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,522 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_3 );
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,526 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,530 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_10 );
MOVW	R1, #1024
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,544 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_4_fpi_stm32.h,543 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_4_fpi_stm32.h,535 :: 		_SPI_FPCLK_DIV256,
MOVS	R0, #7
;mmb_4_fpi_stm32.h,544 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_4_fpi_stm32.h,546 :: 		}
L_end_hal_mp3_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_mp3_init
netcfg_hal_accel_init:
;mmb_4_fpi_stm32.h,566 :: 		static void hal_accel_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,570 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,574 :: 		GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_2 );
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOF_BASE+0)
MOVT	R0, #hi_addr(GPIOF_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_4_fpi_stm32.h,578 :: 		I2C1_Init_Advanced( 100000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #34464
MOVT	R0, #1
BL	_I2C1_Init_Advanced+0
;mmb_4_fpi_stm32.h,579 :: 		}
L_end_hal_accel_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_accel_init
netcfg_hal_buzzer_init:
;mmb_4_fpi_stm32.h,701 :: 		static void hal_buzzer_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,705 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,709 :: 		Sound_Init( &GPIOB_ODR, 8 );
MOVS	R1, #8
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
BL	_Sound_Init+0
;mmb_4_fpi_stm32.h,710 :: 		}
L_end_hal_buzzer_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_buzzer_init
netcfg_hal_rtc_init:
;mmb_4_fpi_stm32.h,733 :: 		static void hal_rtc_init ( void )
;mmb_4_fpi_stm32.h,739 :: 		RCC_APB1ENR.PWREN = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_APB1ENR+0)
MOVT	R0, #hi_addr(RCC_APB1ENR+0)
_SX	[R0, ByteOffset(RCC_APB1ENR+0)]
;mmb_4_fpi_stm32.h,741 :: 		if ( RCC_BDCR.RTCEN == 0 )
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_netcfg_hal_rtc_init10
;mmb_4_fpi_stm32.h,745 :: 		PWR_CR.DBP = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PWR_CR+0)
MOVT	R0, #hi_addr(PWR_CR+0)
_SX	[R0, ByteOffset(PWR_CR+0)]
;mmb_4_fpi_stm32.h,749 :: 		RTC_WPR = 0xCA;
MOVS	R1, #202
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,750 :: 		RTC_WPR = 0x53;
MOVS	R1, #83
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,758 :: 		RCC_BDCR = 0x00010000;
MOV	R1, #65536
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,759 :: 		RCC_BDCR = 0x00008101;
MOVW	R1, #33025
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,760 :: 		}
L_netcfg_hal_rtc_init10:
;mmb_4_fpi_stm32.h,764 :: 		while ( RTC_ISR.RSF != 1 )
L_netcfg_hal_rtc_init11:
MOVW	R0, #lo_addr(RTC_ISR+0)
MOVT	R0, #hi_addr(RTC_ISR+0)
_LX	[R0, ByteOffset(RTC_ISR+0)]
CMP	R0, #0
IT	NE
BNE	L_netcfg_hal_rtc_init12
;mmb_4_fpi_stm32.h,767 :: 		}
IT	AL
BAL	L_netcfg_hal_rtc_init11
L_netcfg_hal_rtc_init12:
;mmb_4_fpi_stm32.h,771 :: 		while ( RCC_BDCR.LSERDY != 1 )
L_netcfg_hal_rtc_init13:
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_netcfg_hal_rtc_init14
;mmb_4_fpi_stm32.h,774 :: 		}
IT	AL
BAL	L_netcfg_hal_rtc_init13
L_netcfg_hal_rtc_init14:
;mmb_4_fpi_stm32.h,776 :: 		RTC_WPR = 0xFF;
MOVS	R1, #255
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_4_fpi_stm32.h,777 :: 		}
L_end_hal_rtc_init:
BX	LR
; end of netcfg_hal_rtc_init
netcfg_hal_usb_init:
;mmb_4_fpi_stm32.h,791 :: 		static void hal_usb_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_4_fpi_stm32.h,795 :: 		GPIO_Alternate_Function_Enable( &_GPIO_MODULE_OTG_FS_PA89_10_11_12 );
MOVW	R0, #lo_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
BL	_GPIO_Alternate_Function_Enable+0
;mmb_4_fpi_stm32.h,799 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_4_fpi_stm32.h,803 :: 		BSP_USB_PSW = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_4_fpi_stm32.h,804 :: 		Delay_ms( 100 );
MOVW	R7, #2302
MOVT	R7, #61
NOP
NOP
L_netcfg_hal_usb_init15:
SUBS	R7, R7, #1
BNE	L_netcfg_hal_usb_init15
NOP
NOP
NOP
;mmb_4_fpi_stm32.h,805 :: 		BSP_USB_PSW = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_4_fpi_stm32.h,806 :: 		}
L_end_hal_usb_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of netcfg_hal_usb_init
