#line 1 "D:/Test Procedure/Mikromedije/STM32/mikromedia 4 FPI for STM32 CAPACITIVE/SW/mikromedia-sdk/test/modules/rtc_test.c"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/test/test_types.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 40 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/test/test_types.h"
typedef enum
{
 TEST_PREINIT,
 TEST_INIT,
 TEST_TASK

} test_step_t;

typedef struct
{
 test_step_t step;
 uint16_t delay;
 uint8_t name[16];

} test_param_t;

typedef void ( * test_procedure )( test_param_t * );
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/test/console/test_console.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/bsp.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/bsp/mmb.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/bsp/mmb_4_fpi.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/compiler/compiler.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/compiler/mikroc_arm.h"
#line 41 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/compiler/mikroc_arm.h"
typedef void ( * hal_spi_write_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_spi_read_fp_t ) ( unsigned int );

typedef struct
{
 hal_spi_write_fp_t spi_write;
 hal_spi_read_fp_t spi_read;

} hal_spi_obj_t;

typedef unsigned int ( * hal_i2c_start_fp_t ) ( void );
typedef unsigned int ( * hal_i2c_write_fp_t ) ( unsigned char, unsigned char *, unsigned long, unsigned long );
typedef void ( * hal_i2c_read_fp_t ) ( unsigned char, unsigned char *, unsigned long, unsigned long );

typedef struct
{
 hal_i2c_start_fp_t i2c_start;
 hal_i2c_write_fp_t i2c_write;
 hal_i2c_read_fp_t i2c_read;

} hal_i2c_obj_t;

typedef void ( * hal_uart_write_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_uart_read_fp_t ) ( void );
typedef unsigned int ( * hal_uart_ready_fp_t ) ( void );

typedef struct
{
 hal_uart_write_fp_t uart_write;
 hal_uart_read_fp_t uart_read;
 hal_uart_ready_fp_t uart_ready;

} hal_uart_obj_t;

typedef void ( * hal_pwm_duty_fp_t ) ( unsigned int, char, char );

typedef void ( * hal_pwm_stop_fp_t ) ( char );

typedef struct
{
 hal_pwm_duty_fp_t pwm_duty;

 hal_pwm_stop_fp_t pwm_stop;

} hal_pwm_obj_t;

typedef unsigned int ( * hal_adc_read_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_adc_sample_fp_t ) ( unsigned int );

typedef struct
{
 hal_adc_read_fp_t adc_read;
 hal_adc_sample_fp_t adc_sample;

} hal_adc_obj_t;
#line 79 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
extern sfr sbit TFT_BLED;
extern sfr sbit TFT_CS;
extern sfr sbit TFT_RD;
extern sfr sbit TFT_RS;
extern sfr sbit TFT_RST;
extern sfr sbit TFT_WR;

static void Write_to_Data_Lines ( unsigned char _hi, unsigned char _lo )
{
 unsigned int tmp = GPIOE_ODR;
 tmp &= 0xFF00;
 GPIOE_ODR = tmp | _hi;
 tmp = GPIOE_ODR;
 tmp &= 0xFF00;
 GPIOE_ODR = tmp | _lo;
}

static void Write_to_Data_Lines_8bit ( unsigned char _data )
{
 unsigned int tmp = GPIOE_ODR;
 tmp &= 0xFF00;
 GPIOE_ODR = tmp | _data;
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Set_Index ( unsigned short index )
{
 TFT_RS = 0;
 Write_to_Data_Lines(0, index);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Write_Command ( unsigned short cmd )
 {
 TFT_RS = 1;
 Write_to_Data_Lines(0, cmd);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Write_Data ( unsigned int _data )
{
 volatile unsigned short temp;

 TFT_RS = 1;
 temp = (_data>>11);
 temp = (temp<<3);

 if ((temp>>7) == 1)
 {
 temp += 7;
 }

 Write_to_Data_Lines_8bit(temp);
 temp = (_data>>5);
 temp = (temp<<2);

 if ((temp>>7) == 1)
 {
 temp += 3;
 }

 Write_to_Data_Lines_8bit(temp);
 temp = (_data<<3);

 if ((temp>>7) == 1)
 {
 temp += 7;
 }

 Write_to_Data_Lines_8bit(temp);
}

static void hal_display_init ( void )
{


 TFT_Set_Active( Set_Index, Write_Command, Write_Data );
 TFT_Init_SSD1963_Board_43( 480, 272 );
 TFT_Set_DBC_SSD1963( 255 );
}





static uint8_t hal_touch_init ( void )
{


 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );
 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_7 );

 GPIOB_ODR.B6 = 1;

 while (GPIOB_IDR.B7 == 0)
 {
 GPIOB_ODR.B6 = 0;
 Delay_us(10);
 GPIOB_ODR.B6 = 1;
 Delay_us(10);
 }

 I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );

 FT5XX6_SetI2CAddress( 0x38 );

 if (FT5XX6_IsOperational( ) != FT5XX6_OK)
 {
 return FT5XX6_FAILURE;
 }

 FT5XX6_SetDefaultMode( );
 FT5XX6_SetController( _TC_FT5X16 );
 FT5XX6_SetSizeAndRotation( 480, 272, 0 );

 return FT5XX6_OK;
}
#line 213 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
static void hal_console_init ( void )
{


 UART2_Init_Advanced(
 115200,
 _UART_8_BIT_DATA,
 _UART_NOPARITY,
 _UART_ONE_STOPBIT,
 &_GPIO_MODULE_USART2_PD5_PA3
 );
}









static sbit BSP_DC_STATUS at GPIOB_IDR.B12;



static sbit BSP_CHARGER_STATUS at GPIOB_IDR.B1;
#line 251 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
const static hal_adc_obj_t BSP_POWER_ADC_MODULE =
{
 ADC3_Read,
 ADC3_Get_Sample
};

static void hal_power_init ( void )
{


 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_1 );



 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_12 );



 GPIO_Analog_Input( &GPIOC_BASE, _GPIO_PINMASK_3 );



 ADC_Set_Input_Channel( _ADC_CHANNEL_13 );

 ADC3_Init( );
}
#line 294 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
static void hal_microsd_init ( void )
{
#line 317 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
 GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_3 );
 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_2 );

 SDIO_Reset( );

 SDIO_Init( _SDIO_CFG_POWER_SAVE_DISABLE | _SDIO_CFG_4_WIDE_BUS_MODE | _SDIO_CFG_CLOCK_BYPASS_DISABLE
 | _SDIO_CFG_CLOCK_RISING_EDGE | _SDIO_CFG_HW_FLOW_DISABLE, 125, &_GPIO_MODULE_SDIO_D0_D3 );


 GPIOD_PUPDRbits.PUPDR2 = 1;
 GPIOC_PUPDRbits.PUPDR8 = 1;
 GPIOC_PUPDRbits.PUPDR9 = 1;
 GPIOC_PUPDRbits.PUPDR10 = 1;
 GPIOC_PUPDRbits.PUPDR11 = 1;

 Mmc_Set_Interface( _MMC_INTERFACE_SDIO );


}









static sbit BSP_FLASH_CE at GPIOC_ODR.B13;

const static hal_spi_obj_t BSP_FLASH_SPI_MODULE =
{
 SPI2_Write,
 SPI2_Read
};

static void hal_flash_init ( void )
{


 GPIO_Digital_Output( &GPIOC_BASE, _GPIO_PINMASK_13 );



 SPI2_Init_Advanced(
 _SPI_FPCLK_DIV32,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI2_PB13_14_15
 );

 BSP_FLASH_CE = 1;
}
#line 456 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
static sbit BSP_RF_CS at GPIOB_ODR.B4;
static sbit BSP_RF_CE at GPIOD_ODR.B13;
static sbit BSP_RF_INT at GPIOD_IDR.B0;

const static hal_spi_obj_t BSP_RF_SPI_MODULE =
{
 SPI2_Write,
 SPI2_Read
};

static void hal_rf_init ( void )
{


 GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_0 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_13 );



 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_4 );



 SPI2_Init_Advanced(
 _SPI_FPCLK_DIV16,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI2_PB13_14_15
 );
}








static volatile sbit BSP_MP3_DREQ at GPIOD_IDR.B9;
static volatile sbit BSP_MP3_CS at GPIOB_ODR.B3;
static volatile sbit BSP_MP3_RST at GPIOD_ODR.B8;
static volatile sbit BSP_MP3_DCS at GPIOD_ODR.B10;

static const hal_spi_obj_t BSP_MP3_SPI_MODULE =
{
 SPI2_Write,
 SPI2_Read
};

static void hal_mp3_init ( void )
{


 GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_9 );



 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_3 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_8 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_10 );



 SPI2_Init_Advanced(
 _SPI_FPCLK_DIV256,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI2_PB13_14_15
 );
}









static sbit BSP_ACCEL_INT_1 at GPIOB_IDR.B9;
static sbit BSP_ACCEL_INT_2 at GPIOF_IDR.B2;

const static hal_i2c_obj_t BSP_ACCEL_I2C_MODULE =
{
 I2C1_Start,
 I2C1_Write,
 I2C1_Read
};

static void hal_accel_init ( void )
{


 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_9 );



 GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_2 );



 I2C1_Init_Advanced( 100000, &_GPIO_MODULE_I2C1_PB67 );
}
#line 701 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
static void hal_buzzer_init ( void )
{


 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_8 );



 Sound_Init( &GPIOB_ODR, 8 );
}
#line 733 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
static void hal_rtc_init ( void )
{




 RCC_APB1ENR.PWREN = 1;

 if ( RCC_BDCR.RTCEN == 0 )
 {


 PWR_CR.DBP = 1;



 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;
#line 758 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
 RCC_BDCR = 0x00010000;
 RCC_BDCR = 0x00008101;
 }



 while ( RTC_ISR.RSF != 1 )
 {

 }



 while ( RCC_BDCR.LSERDY != 1 )
 {

 }

 RTC_WPR = 0xFF;
}
#line 789 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/mmb_4_fpi_stm32.h"
static sbit BSP_USB_PSW at GPIOD_ODR.B6;

static void hal_usb_init ( void )
{


 GPIO_Alternate_Function_Enable( &_GPIO_MODULE_OTG_FS_PA89_10_11_12 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_6 );



 BSP_USB_PSW = 1;
 Delay_ms( 100 );
 BSP_USB_PSW = 0;
}
#line 88 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/test/console/test_console.h"
typedef enum
{
 HEX_FORMAT,
 BYTE_FORMAT,
 SIGNED_WORD_FORMAT,
 UNSIGNED_WORD_FORMAT,
 SIGNED_LONG_FORMAT,
 UNSIGNED_LONG_FORMAT,
 FLOAT_FORMAT,
 STRING_FORMAT

} data_format_t;



void test_console_write_text ( uint8_t * x );

void test_console_write_line ( uint8_t * x );

uint8_t test_console_read ( void );

void test_console_init ( void );

void test_sequence_start ( void );

void test_sequence_finish ( void );

void test_console_header ( uint8_t * desc );

void test_console_sub_header ( uint8_t * desc, uint8_t * info );

void test_console_operation ( uint8_t step, uint8_t * desc );

void test_console_output ( uint8_t * desc, void * output, data_format_t fmt, uint8_t * fin );
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/driver/bsp_rtc_driver.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/portable/bsp.h"
#line 39 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/driver/bsp_rtc_driver.h"
typedef struct
{
 uint8_t ampm;

 uint8_t hr;
 uint8_t min;
 uint8_t sec;

 uint8_t d;
 uint8_t m;
 uint16_t y;

} rtc_time_t;
#line 57 "d:/test procedure/mikromedije/stm32/mikromedia 4 fpi for stm32 capacitive/sw/mikromedia-sdk/driver/bsp_rtc_driver.h"
void bsp_rtc_init ( void );

void bsp_rtc_get ( rtc_time_t * time );

void bsp_rtc_set ( rtc_time_t * time );
#line 41 "D:/Test Procedure/Mikromedije/STM32/mikromedia 4 FPI for STM32 CAPACITIVE/SW/mikromedia-sdk/test/modules/rtc_test.c"
static rtc_time_t MY_TIME =
{
 0,

 10,
 0,
 0,

 4,
 12,
 82
};

static rtc_time_t tmp;



void print_time ( rtc_time_t * t )
{
 test_console_output( "TIME", ( void * ) &t->hr, BYTE_FORMAT, ":" );
 test_console_output( "", ( void * ) &t->min, BYTE_FORMAT, ":" );
 test_console_output( "", ( void * ) &t->sec, BYTE_FORMAT, "\r\n" );
}

void rtc_test ( test_param_t * tp )
{
 switch ( tp->step )
 {
 case TEST_PREINIT :
 {
 tp->step = TEST_INIT;
 tp->delay =  780 ;
 strcpy( tp->name,  "RTC Test"  );

 break;
 }
 case TEST_INIT :
 {



 bsp_rtc_init( );




 test_console_operation( 1, "Time set : " );
 bsp_rtc_set( &MY_TIME );
 print_time( &MY_TIME );




 tp->step = TEST_TASK;

 test_console_operation( 2, "Time get : " );
 break;
 }
 case TEST_TASK :
 {



 bsp_rtc_get( &tmp );
 print_time( &tmp );
 test_console_write_line(  ((void *)0)  );




 break;
 }
 }
}
